// $Id: Gtkmm_OStream.cc,v 1.7 1998/07/06 12:48:24 cvs Exp $

#include "Gtkmm_OStream.h"
#include <gtk--/listitem.h>
#include <cstring>
#include <iomanip.h>

#define CLIST_COLUMNS 20

void Gtkmm_OStream::flush()
{  put(0);
   ostrstream::flush();
   char *linebuf=str();

   switch (Typ)
   {  case List:
        {// if (mode&ios::trunc) delete existing lines
         const char *nextline=linebuf;
         Gtk_ListItem *item;
         for (char *nl=strchr(nextline,'\n');nl;nextline=nl+1,nl=strchr(nextline,'\n'))
         {  nl[0]=0; 
            item=new Gtk_ListItem(nextline);
            ((Gtk_List*)widget)->add(item);
            item->show();

         }
         if (nextline[0])
         {  item=new Gtk_ListItem(nextline);
            ((Gtk_List*)widget)->add(item);
            item->show();
         }
        }
         break;
      case CList:
        {const char *nextline=linebuf;
	 const char *columns[CLIST_COLUMNS];
	 ((Gtk_CList*)widget)->freeze();
         for (char *nl=strchr(nextline,'\n');nl;nextline=nl+1,nl=strchr(nextline,'\n'))
         {  nl[0]=0;
            const char *nextcol=nextline;
            int numcol=0;
            for (char *nc=strchr(nextcol,'\t');nc && numcol<CLIST_COLUMNS
            		;nextcol=nc+1,nc=strchr(nextcol,'\t'),numcol++)
	    {  nc[0]=0;
               columns[numcol]=nextcol;
	    }
	    if (nextcol[0] && numcol<CLIST_COLUMNS)
	    {  columns[numcol++]=nextcol;
	    }
	    for (int i=numcol;i<CLIST_COLUMNS;i++) columns[i]="";
	    ((Gtk_CList*)widget)->append((char**)columns);
         }
         if (nextline[0])
         {  const char *nextcol=nextline;
            int numcol=0;
            for (char *nc=strchr(nextcol,'\t');nc && numcol<CLIST_COLUMNS
            		;nextcol=nc+1,nc=strchr(nextcol,'\t'),numcol++)
	    {  nc[0]=0;
               columns[numcol]=nextcol;
	    }
	    if (nextcol[0] && numcol<CLIST_COLUMNS)
	    {  columns[numcol++]=nextcol;
	    }
	    for (int i=numcol;i<CLIST_COLUMNS;i++) columns[i]="";
	    ((Gtk_CList*)widget)->append((char**)columns);
         }
         ((Gtk_CList*)widget)->thaw();
        }
         break;
      case CxxStream:
         cerr << linebuf << ::flush;
         break;
      default:
         cerr << "Gtkmm_OStream::flush(): Function not implemented\n";
         break;
   }
   
   freeze(0); // we don't need the buffer any more
   seekp(0,ios::beg);
   if (flushhook) (*flushhook)(fh_data);
}
