// $Id: Gtkmm_OStream.h,v 1.7 1998/07/06 15:40:49 cvs Exp $

#ifndef GTKMM_OSTREAM_H
#define GTKMM_OSTREAM_H
#include <iostream.h> // <iostream> for newer compilers
#include <strstream.h> // <strstream> for newer compilers
#include <gtk--/list.h>
#include <gtk--/clist.h>
#include <gtk--/label.h>

// if you have gcc 2.7 uncomment this line
// #define NO_EXCEPTIONS

#ifdef NO_EXCEPTIONS
#define throw(away...)
#endif

// 2do: option-menu, combo-box, Button, ... (everything which has Text on it)

class Gtkmm_OStream : public ostrstream
{
public:
	enum Typ { List,CList,CListCol,Label,CxxStream } Typ;
private:
	typedef void (*hookfunc)(void *);

	gint row,column;
	int mode;
	Gtk_Widget *widget;
	hookfunc flushhook;
	void *fh_data;
public:
	Gtkmm_OStream() throw()
		: Typ(CxxStream), mode(ios::out), widget(0), flushhook(0) {}
	Gtkmm_OStream(Gtk_CList *cl,int _mode=(ios::out|ios::app)) throw()
		: Typ(CList), mode(_mode), widget(cl), flushhook(0) {}
	Gtkmm_OStream(Gtk_CList *cl,gint _row,gint _column,int _mode=(ios::out|ios::trunc))
			throw()
		: Typ(CListCol), row(_row), column(_column), mode(_mode), 
		  widget(cl), flushhook(0) {}
	Gtkmm_OStream(Gtk_List *l,int _mode=(ios::out|ios::app)) throw()
		: Typ(List), mode(_mode), widget(l), flushhook(0) {}
	Gtkmm_OStream(Gtk_Label *l,int _mode=(ios::out|ios::trunc)) throw()
		: Typ(Label), mode(_mode), widget(l), flushhook(0) {}
	~Gtkmm_OStream(void)
	{  flush();
	}
	// this routine does the hard work
	void flush(void);
	// register a function to call on output (flush) (e.g. to scroll)
	void onFlush(hookfunc hook,void *data) throw()
	{  flushhook=hook; fh_data=data; }
};

#endif
